Index: ChangeLog
===================================================================
RCS file: /thubanrepository/thuban/ChangeLog,v
retrieving revision 1.771
diff -u -r1.771 ChangeLog
--- ChangeLog	24 Jan 2005 11:19:53 -0000	1.771
+++ ChangeLog	24 Jan 2005 22:59:16 -0000
@@ -1,3 +1,77 @@
+2005-01-24  Jonathan Coles <jonathan@intevation.de>
+
+	Add a new dialog box for raster layers. The dialog box allows
+	the user to specify which color is used for a mask. Change
+	the projection code to support a mask specified in Thuban.
+
+	* Thuban/UI/baserenderer.py (BaseRenderer.draw_raster_layer):
+	If the raster layer has a mask color, tell the warping code
+	to use it for the NO_DATA values.
+
+	* Thuban/UI/classifier.py (Classifier): Change the parent class
+	to LayerProperties and rework the code to support layout calls
+	from the parent.
+	(Classifier.dialog_layout): New. Layout the dialog box.
+	(Classifier.map_layers_removed): Removed. Moved to parent class.
+	(Classifier.map_replaced): Removed. Moved to parent class.
+	(Classifier._OnTry): Renamed to OnTry to support parent class.
+	(Classifier.OnClose): Removed. Supplied in parent class.
+	(Classifier._OnCloseBtn): Removed. Supplied in parent class as OnCloseBtn.
+	(Classifier._OnOK): Renamed to OnOK to support parent class.
+	(Classifier._OnRevert): Renamed to OnRevert to support parent class.
+
+	* Thuban/Model/color.py (hex2Color): New. Converts a string in the
+	form #rrggbb to a Color object.
+	(Color2hex): Converts a Color object to a string in the form #rrggbb.
+	Although Color.hex() performs the same function, the symmetry with
+	hex2Color is cleaner. It may also be inappropriate to have a hex()
+	method.
+
+	* libraries/thuban/gdalwarp.cpp (GetImageData): Add support for
+	variables mask colors. Try to support images that have more than
+	three bands, such as images with RGB plus an alpha band.
+	(ProjectRasterFile): Convert python argument for mask and tell
+	gdal to use it for the NO_DATA values.
+
+	* Thuban/Model/layer.py (BaseLayer.Type): New. Returns a string
+	describing what kind of layer the class is. Defaults to "Unknown",
+	but should be overridden by subclasses.
+	(Layer.Type): New. Override base class method.
+	(RasterLayer.__init__): Create variables for the mask color and
+	a flag for using it. Record extra data from gdal for display in
+	the properties dialog.
+	(RasterLayer.Type): New. Override base class method.
+	(RasterLayer.HasMask): New. Returns True if the layer has a mask.
+	(RasterLayer.UseMask): New. Returns True if the mask should be used.
+	(RasterLayer.SetUseMask): New. Set if the mask should be used.
+	(RasterLayer.MaskColor): New. Return the mask color.
+	(RasterLayer.SetMaskColor): New. Set the mask color to be used.
+	(RasterLayer.ImageInfo): New. Return extra information about the image.
+
+	* Thuban/Model/load.py (SessionLoader.start_rasterlayer): Load
+	the mask information.
+
+	* Thuban/UI/mainwindow.py: Register the RasterLayerProperties and
+	Classifier classes as dialogs to use with the proper layer types.
+
+	* Thuban/Model/save.py (SessionSaver.write_layer): Save mask information.
+
+	* test/test_baserenderer.py (TestBaseRenderer.test_raster_no_projection):
+	Fix test.
+
+	* test/test_color.py (TestColorConversions): Tests fo hex2Color and
+	Color2hex.
+
+	* test/test_layer.py (TestLayer.test_raster_layer): Test new methods.
+	(TestLayerModification.build_path): New. Support function.
+	(TestLayerModification.test_raster_layer): New. Test new methods.
+
+	* test/test_save.py (SaveSessionTest.testRasterLayer): Add tests for mask.
+
+	* test/test_load.py (TestRasterLayer): Add tests for mask.
+
+	* test/test_load_1_0_1.py: New. Copied from test_load.py.
+
 2005-01-24  Bernhard Herzog  <bh@intevation.de>
 
 	Rework the status bar updates a bit to make sure the message about
